using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

using gudusoft.gsqlparser;
using gudusoft.gsqlparser.Units;

namespace syntaxcheck
{
    class syntaxcheck
    {
        static void Main(string[] args)
        {
            int c = Environment.TickCount;

            if (args.Length == 0)
            {
                Console.WriteLine("Usage:");
                Console.WriteLine("{0} scriptfile", "syntaxcheck");
                return;
            }

            /// Create SQL parser according to different database SQL dialect you need to check
            /// such as Oracle, SQL Server, DB2, MySQL and Access
            /// 
            TGSqlParser sqlparser = new TGSqlParser(TDbVendor.DbVOracle);//DbVMssql
            Console.WriteLine("Time escaped after starting: {0}", Environment.TickCount - c);

           sqlparser.Sqlfilename = args[0];
            // or set sql text
           //sqlparser.SqlText.Text = "select f from t;";

            int iRet = sqlparser.Parse();
            Console.WriteLine("Time escaped after parsing: {0}", Environment.TickCount - c);

            if (iRet == 0){
                Console.WriteLine("Input sql parsed ok!");
                // Console.WriteLine("raw sql \n {0}", sqlparser.SqlStatements[0].SqlStatementType);
            }else{
                Console.WriteLine("Syntax error found in input sql:");
                Console.WriteLine(sqlparser.ErrorMessages);

                #region get more detail error information
                //for (int i = 0; i < sqlparser.ErrorCount; i++)
                //{
                //    Console.WriteLine("Error number: {0}",i);
                //    Console.WriteLine("Error Token: {0}", sqlparser.SyntaxErrors[i].Token );
                //    Console.WriteLine("Error Position: {0},{1}", sqlparser.SyntaxErrors[i].XPosition, sqlparser.SyntaxErrors[i].YPosition);
                //    Console.WriteLine("Hint Message: {0}", sqlparser.SyntaxErrors[i].Hint);
                //}
                #endregion 
            }
        }
    }
}
